#ifndef _QRINFORMATION_H
#define _QRINFORMATION_H

#define	QR_BIT_0	(0x01)
#define	QR_BIT_1	(0x02)
#define	QR_BIT_2	(0x04)
#define	QR_BIT_3	(0x08)
#define	QR_BIT_4	(0x10)
#define	QR_BIT_5	(0x20)
#define	QR_BIT_6	(0x40)
#define	QR_BIT_7	(0x80)

const unsigned char ucBits[] = { QR_BIT_7, QR_BIT_6, QR_BIT_5, QR_BIT_4,
								 QR_BIT_3, QR_BIT_2, QR_BIT_1, QR_BIT_0 };
				

struct STypeMatrix
{
	int m_iModelNumber;		//^
	int m_iCollectLevel;	//G[x
	int m_iDataBitNumber;	//f[^rbg
	int m_iTotalBits;		//R[hrbg
	int m_iRSBlockNumber;	//qrubN
};

//^ԁEG[xɑ΂\\f[^z
const struct STypeMatrix c_typeMatrix[] =
{
	{  1, COLLECTLEVEL_L,   152,   208 ,  1 },
	{  1, COLLECTLEVEL_M,   128,   208 ,  1 },
	{  1, COLLECTLEVEL_Q,   104,   208 ,  1 },
	{  1, COLLECTLEVEL_H,    72,   208 ,  1 },
	{  2, COLLECTLEVEL_L,   272,   352 ,  1 },
	{  2, COLLECTLEVEL_M,   224,   352 ,  1 },
	{  2, COLLECTLEVEL_Q,   176,   352 ,  1 },
	{  2, COLLECTLEVEL_H,   128,   352 ,  1 },
	{  3, COLLECTLEVEL_L,   440,   560 ,  1 },
	{  3, COLLECTLEVEL_M,   352,   560 ,  1 },
	{  3, COLLECTLEVEL_Q,   272,   560 ,  2 },
	{  3, COLLECTLEVEL_H,   208,   560 ,  2 },
	{  4, COLLECTLEVEL_L,   640,   800 ,  1 },
	{  4, COLLECTLEVEL_M,   512,   800 ,  2 },
	{  4, COLLECTLEVEL_Q,   384,   800 ,  2 },
	{  4, COLLECTLEVEL_H,   288,   800 ,  4 },
	{  5, COLLECTLEVEL_L,   864,  1072 ,  1 },
	{  5, COLLECTLEVEL_M,   688,  1072 ,  2 },
	{  5, COLLECTLEVEL_Q,   496,  1072 ,  4 },
	{  5, COLLECTLEVEL_H,   368,  1072 ,  4 },
	{  6, COLLECTLEVEL_L,  1088,  1376 ,  2 },
	{  6, COLLECTLEVEL_M,   864,  1376 ,  4 },
	{  6, COLLECTLEVEL_Q,   608,  1376 ,  4 },
	{  6, COLLECTLEVEL_H,   480,  1376 ,  4 },
	{  7, COLLECTLEVEL_L,  1248,  1568 ,  2 },
	{  7, COLLECTLEVEL_M,   992,  1568 ,  4 },
	{  7, COLLECTLEVEL_Q,   704,  1568 ,  6 },
	{  7, COLLECTLEVEL_H,   528,  1568 ,  5 },
	{  8, COLLECTLEVEL_L,  1552,  1936 ,  2 },
	{  8, COLLECTLEVEL_M,  1232,  1936 ,  4 },
	{  8, COLLECTLEVEL_Q,   880,  1936 ,  6 },
	{  8, COLLECTLEVEL_H,   688,  1936 ,  6 },
	{  9, COLLECTLEVEL_L,  1856,  2336 ,  2 },
	{  9, COLLECTLEVEL_M,  1456,  2336 ,  5 },
	{  9, COLLECTLEVEL_Q,  1056,  2336 ,  8 },
	{  9, COLLECTLEVEL_H,   800,  2336 ,  8 },
	{ 10, COLLECTLEVEL_L,  2192,  2768 ,  4 },
	{ 10, COLLECTLEVEL_M,  1728,  2768 ,  5 },
	{ 10, COLLECTLEVEL_Q,  1232,  2768 ,  8 },
	{ 10, COLLECTLEVEL_H,   976,  2768 ,  8 },
	{ 11, COLLECTLEVEL_L,  2592,  3232 ,  4 },
	{ 11, COLLECTLEVEL_M,  2032,  3232 ,  5 },
	{ 11, COLLECTLEVEL_Q,  1440,  3232 ,  8 },
	{ 11, COLLECTLEVEL_H,  1120,  3232 , 11 },
	{ 12, COLLECTLEVEL_L,  2960,  3728 ,  4 },
	{ 12, COLLECTLEVEL_M,  2320,  3728 ,  8 },
	{ 12, COLLECTLEVEL_Q,  1648,  3728 , 10 },
	{ 12, COLLECTLEVEL_H,  1264,  3728 , 11 },
	{ 13, COLLECTLEVEL_L,  3424,  4256 ,  4 },
	{ 13, COLLECTLEVEL_M,  2672,  4256 ,  9 },
	{ 13, COLLECTLEVEL_Q,  1952,  4256 , 12 },
	{ 13, COLLECTLEVEL_H,  1440,  4256 , 16 },
	{ 14, COLLECTLEVEL_L,  3688,  4648 ,  4 },
	{ 14, COLLECTLEVEL_M,  2920,  4648 ,  9 },
	{ 14, COLLECTLEVEL_Q,  2088,  4648 , 16 },
	{ 14, COLLECTLEVEL_H,  1576,  4648 , 16 },
	{ 15, COLLECTLEVEL_L,  4184,  5240 ,  6 },
	{ 15, COLLECTLEVEL_M,  3320,  5240 , 10 },
	{ 15, COLLECTLEVEL_Q,  2360,  5240 , 12 },
	{ 15, COLLECTLEVEL_H,  1784,  5240 , 18 },
	{ 16, COLLECTLEVEL_L,  4712,  5864 ,  6 },
	{ 16, COLLECTLEVEL_M,  3624,  5864 , 10 },
	{ 16, COLLECTLEVEL_Q,  2600,  5864 , 17 },
	{ 16, COLLECTLEVEL_H,  2024,  5864 , 16 },
	{ 17, COLLECTLEVEL_L,  5176,  6520 ,  6 },
	{ 17, COLLECTLEVEL_M,  4056,  6520 , 11 },
	{ 17, COLLECTLEVEL_Q,  2936,  6520 , 16 },
	{ 17, COLLECTLEVEL_H,  2264,  6520 , 19 },
	{ 18, COLLECTLEVEL_L,  5768,  7208 ,  6 },
	{ 18, COLLECTLEVEL_M,  4504,  7208 , 13 },
	{ 18, COLLECTLEVEL_Q,  3176,  7208 , 18 },
	{ 18, COLLECTLEVEL_H,  2504,  7208 , 21 },
	{ 19, COLLECTLEVEL_L,  6360,  7928 ,  7 },
	{ 19, COLLECTLEVEL_M,  5016,  7928 , 14 },
	{ 19, COLLECTLEVEL_Q,  3560,  7928 , 21 },
	{ 19, COLLECTLEVEL_H,  2728,  7928 , 25 },
	{ 20, COLLECTLEVEL_L,  6888,  8680 ,  8 },
	{ 20, COLLECTLEVEL_M,  5352,  8680 , 16 },
	{ 20, COLLECTLEVEL_Q,  3880,  8680 , 20 },
	{ 20, COLLECTLEVEL_H,  3080,  8680 , 25 },
	{ 21, COLLECTLEVEL_L,  7456,  9248 ,  8 },
	{ 21, COLLECTLEVEL_M,  5712,  9248 , 17 },
	{ 21, COLLECTLEVEL_Q,  4096,  9248 , 23 },
	{ 21, COLLECTLEVEL_H,  3248,  9248 , 25 },
	{ 22, COLLECTLEVEL_L,  8048, 10064 ,  9 },
	{ 22, COLLECTLEVEL_M,  6256, 10064 , 17 },
	{ 22, COLLECTLEVEL_Q,  4544, 10064 , 23 },
	{ 22, COLLECTLEVEL_H,  3536, 10064 , 34 },
	{ 23, COLLECTLEVEL_L,  8752, 10912 ,  9 },
	{ 23, COLLECTLEVEL_M,  6880, 10912 , 18 },
	{ 23, COLLECTLEVEL_Q,  4912, 10912 , 25 },
	{ 23, COLLECTLEVEL_H,  3712, 10912 , 30 },
	{ 24, COLLECTLEVEL_L,  9392, 11792 , 10 },
	{ 24, COLLECTLEVEL_M,  7312, 11792 , 20 },
	{ 24, COLLECTLEVEL_Q,  5312, 11792 , 27 },
	{ 24, COLLECTLEVEL_H,  4112, 11792 , 32 },
	{ 25, COLLECTLEVEL_L, 10208, 12704 , 12 },
	{ 25, COLLECTLEVEL_M,  8000, 12704 , 21 },
	{ 25, COLLECTLEVEL_Q,  5744, 12704 , 29 },
	{ 25, COLLECTLEVEL_H,  4304, 12704 , 35 },
	{ 26, COLLECTLEVEL_L, 10960, 13648 , 12 },
	{ 26, COLLECTLEVEL_M,  8496, 13648 , 23 },
	{ 26, COLLECTLEVEL_Q,  6032, 13648 , 34 },
	{ 26, COLLECTLEVEL_H,  4768, 13648 , 37 },
	{ 27, COLLECTLEVEL_L, 11744, 14624 , 12 },
	{ 27, COLLECTLEVEL_M,  9024, 14624 , 25 },
	{ 27, COLLECTLEVEL_Q,  6464, 14624 , 34 },
	{ 27, COLLECTLEVEL_H,  5024, 14624 , 40 },
	{ 28, COLLECTLEVEL_L, 12248, 15368 , 13 },
	{ 28, COLLECTLEVEL_M,  9544, 15368 , 26 },
	{ 28, COLLECTLEVEL_Q,  6968, 15368 , 35 },
	{ 28, COLLECTLEVEL_H,  5288, 15368 , 42 },
	{ 29, COLLECTLEVEL_L, 13048, 16408 , 14 },
	{ 29, COLLECTLEVEL_M, 10136, 16408 , 28 },
	{ 29, COLLECTLEVEL_Q,  7288, 16408 , 38 },
	{ 29, COLLECTLEVEL_H,  5608, 16408 , 45 },
	{ 30, COLLECTLEVEL_L, 13880, 17480 , 15 },
	{ 30, COLLECTLEVEL_M, 10984, 17480 , 29 },
	{ 30, COLLECTLEVEL_Q,  7880, 17480 , 40 },
	{ 30, COLLECTLEVEL_H,  5960, 17480 , 48 },
	{ 31, COLLECTLEVEL_L, 14744, 18584 , 16 },
	{ 31, COLLECTLEVEL_M, 11640, 18584 , 31 },
	{ 31, COLLECTLEVEL_Q,  8264, 18584 , 43 },
	{ 31, COLLECTLEVEL_H,  6344, 18584 , 51 },
	{ 32, COLLECTLEVEL_L, 15640, 19720 , 17 },
	{ 32, COLLECTLEVEL_M, 12328, 19720 , 33 },
	{ 32, COLLECTLEVEL_Q,  8920, 19720 , 45 },
	{ 32, COLLECTLEVEL_H,  6760, 19720 , 54 },
	{ 33, COLLECTLEVEL_L, 16568, 20888 , 18 },
	{ 33, COLLECTLEVEL_M, 13048, 20888 , 35 },
	{ 33, COLLECTLEVEL_Q,  9368, 20888 , 48 },
	{ 33, COLLECTLEVEL_H,  7208, 20888 , 57 },
	{ 34, COLLECTLEVEL_L, 17528, 22088 , 19 },
	{ 34, COLLECTLEVEL_M, 13800, 22088 , 37 },
	{ 34, COLLECTLEVEL_Q,  9848, 22088 , 51 },
	{ 34, COLLECTLEVEL_H,  7688, 22088 , 60 },
	{ 35, COLLECTLEVEL_L, 18448, 23008 , 19 },
	{ 35, COLLECTLEVEL_M, 14496, 23008 , 38 },
	{ 35, COLLECTLEVEL_Q, 10288, 23008 , 53 },
	{ 35, COLLECTLEVEL_H,  7888, 23008 , 63 },
	{ 36, COLLECTLEVEL_L, 19472, 24272 , 20 },
	{ 36, COLLECTLEVEL_M, 15312, 24272 , 40 },
	{ 36, COLLECTLEVEL_Q, 10832, 24272 , 56 },
	{ 36, COLLECTLEVEL_H,  8432, 24272 , 66 },
	{ 37, COLLECTLEVEL_L, 20528, 25568 , 21 },
	{ 37, COLLECTLEVEL_M, 15936, 25568 , 43 },
	{ 37, COLLECTLEVEL_Q, 11408, 25568 , 59 },
	{ 37, COLLECTLEVEL_H,  8768, 25568 , 70 },
	{ 38, COLLECTLEVEL_L, 21616, 26896 , 22 },
	{ 38, COLLECTLEVEL_M, 16816, 26896 , 45 },
	{ 38, COLLECTLEVEL_Q, 12016, 26896 , 62 },
	{ 38, COLLECTLEVEL_H,  9136, 26896 , 74 },
	{ 39, COLLECTLEVEL_L, 22496, 28256 , 24 },
	{ 39, COLLECTLEVEL_M, 17728, 28256 , 47 },
	{ 39, COLLECTLEVEL_Q, 12656, 28256 , 65 },
	{ 39, COLLECTLEVEL_H,  9776, 28256 , 77 },
	{ 40, COLLECTLEVEL_L, 23648, 29648 , 25 },
	{ 40, COLLECTLEVEL_M, 18672, 29648 , 49 },
	{ 40, COLLECTLEVEL_Q, 13328, 29648 , 68 },
	{ 40, COLLECTLEVEL_H, 10208, 29648 , 81 },
	{ -1,             -1,     0,     0 ,  0 }	//I[f[^
};

//ʒu킹p^[
const short c_sPositionChecks[][8] =
{
	{0,0,0,0,0,0,0,0},
	{6,18,0,0,0,0,0,0},
	{6,22,0,0,0,0,0,0},
	{6,26,0,0,0,0,0,0},
	{6,30,0,0,0,0,0,0},
	{6,34,0,0,0,0,0,0},
	{6,22,38,0,0,0,0,0},
	{6,24,42,0,0,0,0,0},
	{6,26,46,0,0,0,0,0},
	{6,28,50,0,0,0,0,0},
	{6,30,54,0,0,0,0,0},
	{6,32,58,0,0,0,0,0},
	{6,34,62,0,0,0,0,0},
	{6,26,46,66,0,0,0,0},
	{6,26,48,70,0,0,0,0},
	{6,26,50,74,0,0,0,0},
	{6,30,54,78,0,0,0,0},
	{6,30,56,82,0,0,0,0},
	{6,30,58,86,0,0,0,0},
	{6,34,62,90,0,0,0,0},
	{6,28,50,72,94,0,0,0},
	{6,26,50,74,98,0,0,0},
	{6,30,54,78,102,0,0,0},
	{6,28,54,80,106,0,0,0},
	{6,32,58,84,110,0,0,0},
	{6,30,58,86,114,0,0,0},
	{6,34,62,90,118,0,0,0},
	{6,26,50,74,98,122,0,0},
	{6,30,54,78,102,126,0,0},
	{6,26,52,78,104,130,0,0},
	{6,30,56,82,108,134,0,0},
	{6,34,60,86,112,138,0,0},
	{6,30,58,86,114,142,0,0},
	{6,34,62,90,118,146,0,0},
	{6,30,54,78,102,126,150,0},
	{6,24,50,76,102,128,154,0},
	{6,28,54,80,106,132,158,0},
	{6,32,58,84,110,136,162,0},
	{6,26,54,82,110,138,166,0},
	{6,30,58,86,114,142,170,0}
};

char cszQrAlphabets[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ $%*+-./;";

#endif
