#include <iostream>
#include "QRMatrix.h"

#define MODE_NUMERIC		//f[^̏o
#define	MODE_ALPHABET		//At@xbgf[^̏o
#define	MODE_ASCII			//AXL[f[^̏o
#define	MODE_KANJI			//f[^̏o

int main()
{

	CQRMatrix qrMatrix;

#ifdef MODE_NUMERIC
	qrMatrix.AddQRCharacters( "0123456" , QRCHARACTERTYPE_NUMERIC );
#endif

#ifdef MODE_ALPHABET
	qrMatrix.AddQRCharacters( "ABCDEFG" , QRCHARACTERTYPE_ALPHABET );
#endif

#ifdef MODE_ASCII
	qrMatrix.AddQRCharacters( "\nhttp://www.spoonsoftware.com\n" , QRCHARACTERTYPE_ASCII );
#endif

#ifdef MODE_KANJI
	qrMatrix.AddQRCharacters( "@pqeXgp^[@" , QRCHARACTERTYPE_KANJI );
#endif

	int iErrorType;

	//QRf[^̍쐬
	//G[x́ij
	//COLLECTLEVEL_L,COLLECTLEVEL_M,COLLECTLEVEL_Q,COLLECTLEVEL_H
	//I
	if( !qrMatrix.MakeQRMatrix( COLLECTLEVEL_M , iErrorType ) )
	{
		cout << "Error Occured! ErrorType is " << iErrorType << endl;
	}
	else
	{
		//sẼf[^`FbNďo
		for( int iRowIndex = 0 ; iRowIndex < qrMatrix.GetModuleNumber() ; iRowIndex++ )
		{
			for( int iColumnIndex = 0 ; iColumnIndex < qrMatrix.GetModuleNumber() ; iColumnIndex++ )
			{
				if( qrMatrix.IsDarkPoint( iColumnIndex , iRowIndex ) )
				{
					cout << "";
				}
				else
				{
					cout << "@";
				}
			}
			cout << endl;
		}
	}

	return 0;
}
