#include <stdio.h>
#include <gd.h>

#include "QRMatrix.h"

#define MODE_NUMERIC		//f[^̏o
#define	MODE_ALPHABET		//At@xbgf[^̏o
#define	MODE_ASCII			//AXL[f[^̏o
#define	MODE_KANJI			//f[^̏o

#define	QRUNITSIZE	4
#define	QRMARGIN	4

int main()
{

	CQRMatrix qrMatrix;

#ifdef MODE_NUMERIC
	qrMatrix.AddQRCharacters( "0123456" , QRCHARACTERTYPE_NUMERIC );
#endif

#ifdef MODE_ALPHABET
	qrMatrix.AddQRCharacters( "ABCDEFG" , QRCHARACTERTYPE_ALPHABET );
#endif

#ifdef MODE_ASCII
	qrMatrix.AddQRCharacters( "\nhttp://www.spoonsoftware.com\n" , QRCHARACTERTYPE_ASCII );
#endif

#ifdef MODE_KANJI
	qrMatrix.AddQRCharacters( "@pqeXgp^[@" , QRCHARACTERTYPE_KANJI );
#endif

	int iErrorType;

	//QRf[^̍쐬
	//G[x́ij
	//COLLECTLEVEL_L,COLLECTLEVEL_M,COLLECTLEVEL_Q,COLLECTLEVEL_H
	//I
	if( !qrMatrix.MakeQRMatrix( COLLECTLEVEL_M , iErrorType ) )
	{
		printf( "Error Occured! ErrorType is %d\n" , iErrorType);
	}
	else
	{
		gdImagePtr im;
		im = gdImageCreate( (qrMatrix.GetModuleNumber() + QRMARGIN*2) * QRUNITSIZE 
						  , (qrMatrix.GetModuleNumber() + QRMARGIN*2) * QRUNITSIZE );
		
		int backcolor  = gdImageColorAllocate( im , 255 , 255 , 255 );
		int frontcolor = gdImageColorAllocate( im ,   0 ,   0 ,   0 );
		
		//wihԂ
		gdImageFilledRectangle(im, 0, 0, (qrMatrix.GetModuleNumber() + QRMARGIN*2) * QRUNITSIZE
										,(qrMatrix.GetModuleNumber() + QRMARGIN*2) * QRUNITSIZE
								, backcolor);
		
		for( int iRowIndex = 0 ; iRowIndex < qrMatrix.GetModuleNumber() ; iRowIndex++ )
		{
			for( int iColumnIndex = 0 ; iColumnIndex < qrMatrix.GetModuleNumber() ; iColumnIndex++ )
			{
				//hԂ|Cg̏ꍇ
				if( qrMatrix.IsDarkPoint( iColumnIndex , iRowIndex ) )
				{
					int x = (iColumnIndex + QRMARGIN) * QRUNITSIZE;
					int y = (iRowIndex    + QRMARGIN) * QRUNITSIZE;

					gdImageFilledRectangle( im , x , y , x + QRUNITSIZE , y + QRUNITSIZE , frontcolor );
				}
			}
		}
		
		//C[Wt@Cɏo
		FILE * fp  = fopen( "qrimage.jpg" , "w" );
		if( fp )
		{
			gdImageJpeg( im , fp , -1 );
			fclose( fp );
		}

		gdImageDestroy( im );
	}

	return 0;
}
